"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var loader_utils_1 = require("loader-utils");
var _1 = require("./");
function getNormalizedOptions() {
    var defaultInjector = function (source, resources) {
        return resources.map(function (_a) {
            var content = _a.content;
            return content;
        }).join('') + source;
    };
    var defaultResolveUrl = true;
    var _a = loader_utils_1.getOptions(this) || {}, patterns = _a.patterns, _b = _a.injector, injector = _b === void 0 ? defaultInjector : _b, _c = _a.resolveUrl, resolveUrl = _c === void 0 ? defaultResolveUrl : _c;
    if (!_1.isString(patterns) && !(Array.isArray(patterns) && patterns.every(_1.isString))) {
        throw new TypeError('[style-resources-loader] Expected options.patterns to be a string or an array of string. '
            + ("Instead received " + typeof patterns + "."));
    }
    if (typeof injector !== 'function') {
        throw new TypeError('[style-resources-loader] Expected options.injector to be a function. '
            + ("Instead received " + typeof injector + "."));
    }
    if (typeof resolveUrl !== 'boolean') {
        throw new TypeError('[style-resources-loader] Expected options.resolveUrl to be a boolean. '
            + ("Instead received " + typeof resolveUrl + "."));
    }
    return {
        patterns: patterns,
        injector: injector,
        resolveUrl: resolveUrl,
    };
}
exports.getNormalizedOptions = getNormalizedOptions;
//# sourceMappingURL=getNormalizedOptions.js.map